GDAL-VECTOR-CLEAN-COVERAGE(1)

NAME
gdal-vector-clean-coverage - Remove gaps and overlaps from a polygon dataset

Added in version 3.12.

SYNOPSIS

    Usage: gdal vector clean-coverage [OPTIONS] <INPUT> <OUTPUT>
    Alter polygon boundaries to make shared edges identical, removing gaps and overlaps
    Positional arguments:
      -i, --input <INPUT>                                  Input vector datasets [required]
      -o, --output <OUTPUT>                                Output vector dataset [required]
    Common Options:
      -h, --help                                           Display help message and exit
      --json-usage                                         Display usage as JSON document and exit
      --config <KEY>=<VALUE>                               Configuration option [may be repeated]
      -q, --quiet                                          Quiet mode (no progress bar)
    Options:
      -l, --layer, --input-layer <INPUT-LAYER>             Input layer name(s) [may be repeated]
      -f, --of, --format, --output-format <OUTPUT-FORMAT>  Output format ("GDALG" allowed)
      --co, --creation-option <KEY>=<VALUE>                Creation option [may be repeated]
      --lco, --layer-creation-option <KEY>=<VALUE>         Layer creation option [may be repeated]
      --overwrite                                          Whether overwriting existing output is allowed
      --update                                             Whether to open existing dataset in update mode
      --overwrite-layer                                    Whether overwriting existing output is allowed
      --append                                             Whether appending to existing layer is allowed
                                                           Mutually exclusive with --upsert
      --output-layer <OUTPUT-LAYER>                        Output layer name
      --skip-errors                                        Skip errors when writing features
      --active-layer <ACTIVE-LAYER>                        Set active layer (if not specified, all)
      --snapping-distance <SNAPPING-DISTANCE>              Distance tolerance for snapping nodes
      --merge-strategy <MERGE-STRATEGY>                    Algorithm to assign overlaps to neighboring polygons. MERGE-STRATEGY=longest-border|max-area|min-area|min-index
      --maximum-gap-width <MAXIMUM-GAP-WIDTH>              Maximum width of a gap to be closed
    Advanced Options:
      --if, --input-format <INPUT-FORMAT>                  Input formats [may be repeated]
      --oo, --open-option <KEY>=<VALUE>                    Open options [may be repeated]
      --output-oo, --output-open-option <KEY>=<VALUE>      Output open options [may be repeated]
      --upsert                                             Upsert features (implies 'append')
                                                           Mutually exclusive with --append

DESCRIPTION

gdal vector clean-coverage modifies boundaries of a polygonal dataset, such that gaps and overlaps between features are removed and shared edges are defined using the same vertices. The resulting dataset will form a polygonal coverage that can be used with gdal vector simplify-coverage.

This command can also be used as a step of gdal vector pipeline, although it requires loading the entire dataset into memory at once.

NOTE: This command requires a GDAL build against the GEOS library (version 3.14 or greater).

  Standard options

--maximum-gap-width <MAXIMUM-GAP-WIDTH>
    Defines the largest area that should be considered a "gap" and merged into an adjacent polygon. Gaps will be merged unless a circle with radius larger than the specified tolerance can be inscribed within the gap. The default maximum gap width is zero, meaning that gaps are not closed.

--merge-strategy <MERGE-STRATEGY>
    Method by which overlaps or gaps should be added to adjacent polygons. Options include: - longest-border (default): add areas to the polygon with which the longest border is shared - max-area: add areas to the largest adjacent polygon - min-area: add areas to the smallest adjacent polygon - min-index: add areas to the adjacent polygon that was read first

--snapping-distance <SNAPPING-DISTANCE>
    Controls the node snapping step, when nearby vertices are snapped together. By default, an automatic snapping distance is determined based on an analysis of the input. Set to zero to turn off all snapping.

--active-layer <ACTIVE-LAYER>
    Set the active layer. When it is specified, only the layer specified by its name will be subject to the processing. Other layers will be not modified. If this option is not specified, all layers will be subject to the processing.

-f, --of, --format, --output-format <OUTPUT-FORMAT>
    Which output vector format to use. Allowed values may be given by gdal --formats | grep vector | grep rw | sort

--co, --creation-option <NAME>=<VALUE>
    Many formats have one or more optional dataset creation options that can be used to control particulars about the file created. For instance, the GeoPackage driver supports creation options to control the version.

    May be repeated.

    The dataset creation options available vary by format driver, and some simple formats have no creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Vector drivers format specific documentation for legal creation options for each format.

    Note that dataset creation options are different from layer creation options.

-lco <NAME>=<VALUE>
    Layer creation option (format specific)

--overwrite
    Allow program to overwrite existing target file or dataset. Otherwise, by default, gdal errors out if the target file or dataset already exists.

  Advanced options

--oo, --open-option <NAME>=<VALUE>
    Dataset open option (format specific).

    May be repeated.

--if, --input-format <format>
    Format/driver name to be attempted to open the input file(s). It is generally not necessary to specify it, but it can be used to skip automatic driver detection, when it fails to select the appropriate driver. This option can be repeated several times to specify several candidate drivers. Note that it does not force those drivers to open the dataset. In particular, some drivers have requirements on file extensions.

    May be repeated.

GDALG OUTPUT (ON-THE-FLY / STREAMED DATASET)

This program supports serializing the command line as a JSON file using the GDALG output format. The resulting file can then be opened as a vector dataset using the GDALG: GDAL Streamed Algorithm driver, and apply the specified pipeline in a on-the-fly / streamed way.

NOTE: However this algorithm is not natively streaming compatible. Consequently a in-memory temporary dataset will be generated, which may cause significant processing time at opening.

EXAMPLES

  Example 1: Create and then simplify a polygonal coverage

    $ gdal vector pipeline read ne_10m_admin_0_countries.shp ! \
                           make-valid ! \
                           clean-coverage ! \
                           simplify-coverage --tolerance 1 ! \
                           write countries.shp

AUTHOR
Dan Baston <dbaston@gmail.com>

COPYRIGHT
1998-2025